# $Id$

export NETWORK_CONFIG='
<window title="Network Configuration" icon-name="gtk-network" window_position="1">
	<vbox>
		<pixmap>
			<input file>data/header.png</input>
		</pixmap>
		<hbox spacing="175">
			<pixmap>
				<input file stock="gtk-network"></input>
			</pixmap>
			<text>
				<label>"Enter Hostname"</label>
			</text>
		</hbox>
		<frame Hostname>
			<entry>
				<input>echo ${NETWORK_HOSTNAME}</input>
				<variable>NETWORK_HOSTNAME</variable>
			</entry>
		</frame>
		<frame Domainname>
			<entry>
				<input>echo ${NETWORK_DOMAIN}</input>
				<variable>NETWORK_DOMAIN</variable>
			</entry>
		</frame>
		<hbox>
			<button>
				<label>back</label>
				<input file stock="gtk-go-back"></input>
			</button>
			<button>
				<label>next</label>
				<input file stock="gtk-go-forward"></input>
			</button>
		</hbox>
	</vbox>
</window>
'

export NETWORK_CONFIG_SELECT='
<window title="Network Configuration" icon-name="gtk-network" window_position="1" resizable="false">
	<vbox>
		<pixmap>
			<input file>data/header.png</input>
		</pixmap>
		<hbox>
			<pixmap>
				<input file stock="gtk-network"></input>
			</pixmap>
			<text>
				<label>Select a network type</label>
			</text>
		</hbox>

		<frame Networking via>
			<radiobutton active="true">
				<label>DHCP</label>
				<variable>NETWORK_DHCP</variable>
			</radiobutton>
			<radiobutton>
				<label>Static</label>
				<variable>NETWORK_STATIC</variable>
			</radiobutton>
			<radiobutton>
				<label>None</label>
				<variable>NETWORK_NONE</variable>
			</radiobutton>
		</frame>

		<hbox>
			<button>
				<label>back</label>
				<input file stock="gtk-go-back"></input>
			</button>
			<button>
				<label>next</label>
				<input file stock="gtk-go-forward"></input>
			</button>
		</hbox>
	</vbox>
</window>
'

export NETWORK_CONFIG_STATIC='
<window title="Network Configuration" icon-name="gtk-network" window_position="1" resizable="false">
	<vbox>
		<pixmap>
			<input file>data/header.png</input>
		</pixmap>
		<hbox spacing="140">
			<pixmap>
				<input file stock="gtk-network"></input>
			</pixmap>
			<text>
				<label>Setup a static network</label>
			</text>
		</hbox>
		<frame Static>

			<text xalign="0">
				<label>IP</label>
			</text>
			<entry>
				<input>echo "${NETWORK_IP}"</input>
				<variable>NETWORK_IP</variable>
			</entry>

			<text xalign="0">
				<label>Netmask</label>
			</text>
			<entry>
				<input>echo "${NETWORK_NETMASK}"</input>
				<variable>NETWORK_NETMASK</variable>
			</entry>

			<text xalign="0">
				<label>Broadcast</label>
			</text>
			<entry>
				<input>echo "${NETWORK_BROADCAST}"</input>
				<variable>NETWORK_BROADCAST</variable>
			</entry>

			<text xalign="0">
				<label>Gateway</label>
			</text>
			<entry>
				<input>echo "${NETWORK_GATEWAY}"</input>
				<variable>NETWORK_GATEWAY</variable>
			</entry>

			<text xalign="0">
				<label>Nameserver</label>
			</text>
			<entry>
				<input>echo "${NETWORK_NAMESERVER}"</input>
				<variable>NETWORK_NAMESERVER</variable>
			</entry>
			<hbox>
				<button>
					<label>back</label>
					<input file stock="gtk-go-back"></input>
				</button>
				<button>
					<label>next</label>
					<input file stock="gtk-go-forward"></input>
				</button>
			</hbox>
		</frame>
	</vbox>
</window>
'

export NETWORK_SELECT_NIC='
<window title="Network Configuration" icon-name="gtk-network" window_position="1" resizable="false">
	<vbox>
		<pixmap>
			<input file>data/header.png</input>
		</pixmap>
		<hbox spacing="140">
			<pixmap>
				<input file stock="gtk-network"></input>
			</pixmap>
			<text>
				<label>Select a available NIC</label>
			</text>
		</hbox>

		<frame Available NICs>
			<table>
				<label>Interface|Description</label>
				<input>source include/hwdetection.sh; get_hwinfo -d netcard | sed "s:;:\|:g"</input>
				<variable>NETWORK_NIC</variable>
			</table>
		</frame>

		<hbox>
			<button>
				<label>back</label>
				<input file stock="gtk-go-back"></input>
			</button>
			<button>
				<label>next</label>
				<input file stock="gtk-go-forward"></input>
			</button>
		</hbox>
	</vbox>
</window>
'

check_static_network_config()
{
	# these are a requirement
	if [[ -z ${NETWORK_IP} ]]
	then
		FAILURE_MESSAGE="No IP-Address given!" rundialog FAILURE_DIALOG
		return 1
	fi

	if [[ -z ${NETWORK_NETMASK} ]]
	then
		FAILURE_MESSAGE="No netmask given!" rundialog FAILURE_DIALOG
		return 1
	fi

	if [[ -z ${NETWORK_BROADCAST} ]]
	then
		FAILURE_MESSAGE="No broadcast given!" rundialog FAILURE_DIALOG
		return 1
	fi

	return 0
}
# needed to be available in the gtk-dialog
export -f check_static_network_config


rundialog_network_config()
{
	rundialog NETWORK_CONFIG
	debug "EXIT='${EXIT}'"

	# save given variables in env
	# they will be shown as default on error
	export NETWORK_HOSTNAME
	export NETWORK_DOMAIN

	case ${EXIT} in
		abort)
			echo "Aborted by user."
			exit 1
			;;
		back)
			# placeholder
			return 1
			;;
		next)
			if [[ -z ${NETWORK_HOSTNAME} ]]
			then
				FAILURE_MESSAGE="No hostname given." \
					rundialog FAILURE_DIALOG
				rundialog_network_config
			elif [[ -z ${NETWORK_DOMAIN} ]]
			then
				FAILURE_MESSAGE="No domain given." \
					rundialog FAILURE_DIALOG
				rundialog_network_config
			fi
			;;
	esac
}

rundialog_network_config_select()
{
	rundialog NETWORK_CONFIG_SELECT
	debug "EXIT='${EXIT}'"

	debug "NETWORK_DHCP='${NETWORK_DHCP}'"
	debug "NETWORK_STATIC='${NETWORK_STATIC}'"
	debug "NETWORK_NONE='${NETWORK_NONE}'"

	case ${EXIT} in
		abort)
			echo "Aborted by user."
			exit 1
			;;
		back)
			rundialog_network_config
			rundialog_network_config_select
			;;
		next)
			if [[ ${NETWORK_NONE} = true ]]
			then
				export NETWORK_METHOD="none"
				WARNING_MESSAGE="Magellan needs network support for further installations.\nOnly a very basic system get installed.\nTo use more packages, you have to setup your networking manually." \
					rundialog WARNING_DIALOG
			else
				# want networking, run nic selection
				rundialog_network_select_nic

				if [[ ${NETWORK_DHCP} = true ]]
				then
					export NETWORK_METHOD="dhcp"

				elif [[ ${NETWORK_STATIC} = true ]]
				then
					export NETWORK_METHOD="static"
					# run static config dialog
					rundialog_network_config_static
				fi
			fi
			;;
	esac
}

rundialog_network_config_static()
{
	rundialog NETWORK_CONFIG_STATIC
	debug "EXIT='${EXIT}'"

	# save given variables in env
	# they will be shown as default on error
	export NETWORK_IP
	export NETWORK_NETMASK
	export NETWORK_GATEWAY
	export NETWORK_NAMESERVER
	export NETWORK_BROADCAST

	case ${EXIT} in
		abort)
			echo "Aborted by user."
			exit 1
			;;
		back)
			rundialog_network_select_nic
			rundialog_network_config_static
			;;
		next)
			if ! check_static_network_config
			then
				rundialog_network_config_static
			fi
			;;
	esac
}

rundialog_network_select_nic()
{
	rundialog NETWORK_SELECT_NIC
	debug "EXIT='${EXIT}'"

	case ${EXIT} in
		abort)
			echo "Aborted by user."
			exit 1
			;;
		back)
			rundialog_network_config_select
			rundialog_network_select_nic
			;;
		next)
			if [[ -z ${NETWORK_NIC} ]]
			then
				FAILURE_MESSAGE="No NIC selected!" \
					rundialog FAILURE_DIALOG
				rundialog_network_select_nic
			fi
			;;
	esac
}

main_networking()
{
	rundialog_network_config
	rundialog_network_config_select
	#rundialog_network_select_nic

	# export all variables
	export NETWORK_HOSTNAME
	export NETWORK_DOMAIN
	export NETWORK_NIC
	export NETWORK_METHOD
	export NETWORK_IP
	export NETWORK_NETMASK
	export NETWORK_BROADCAST
	export NETWORK_GATEWAY
	export NETWORK_NAMESERVER
}
